	'
	' Oh Mummy
	'
	' by Oscar Toledo G. (nanochess)
	' Inspired on simple game with same name included with Amstrad
	'
	' Creation date: Dec/13/2016.
	'

	ON FRAME GOSUB generate_effect

	CONST board_size = 16 * 9 / 8

	DIM board(20)
	DIM surround(20)
	DIM visited(board_size)
	DIM mummy_x(6)
	DIM mummy_y(6)
	DIM mummy_d(6)
	
	PLAY SIMPLE

	'
	' Show title screen
	'
title_screen:
	PLAY OFF
	GOSUB sound_none
	MODE 1
	BORDER 0
	FOR c = 0 TO 7
	SPRITE c,0
	NEXT c
	WAIT
	DEFINE 0,16,title_bitmaps_0
	WAIT
	DEFINE 16,16,title_bitmaps_1
	WAIT
	DEFINE 32,16,title_bitmaps_2
	WAIT
	DEFINE 48,16,title_bitmaps_3
	WAIT
	SCREEN title_cards
	'
	' Difficulty selection
	'
	PRINT AT 153 COLOR 3,"EASY"
	PRINT AT 173 COLOR 3,"MEDIUM"
	PRINT AT 193 COLOR 3,"HARD"
	debounce = 10
	level = 0
select_1:
	WAIT
	PRINT AT level * 20 + 151 COLOR (FRAME AND 4) / 4 + 6,">"
	IF debounce <> 0 THEN
		debounce = debounce - 1
	ELSE
		c = controller_direction(cont AND $1f)
		IF c = 1 THEN debounce = 10:e = 1:GOSUB effect:PRINT AT level * 20 + 151," ":IF level = 0 THEN level = 2 ELSE level = level - 1
		IF c = 4 THEN debounce = 10:e = 1:GOSUB effect:PRINT AT level * 20 + 151," ":IF level = 2 THEN level = 0 ELSE level = level + 1
	END IF
	c = cont AND $E0
	IF c <> $60 AND c <> $A0 and c <> $C0 THEN GOTO select_1

	e = 5:GOSUB effect

	'
	' Start of game
	'
	CLS
	DEFINE 0,16,backgrounds
	WAIT
	DEFINE 32,16,sprites_1
	WAIT
	DEFINE 48,6,sprites_2
	WAIT

	speed = level * 6 + $30
	mummies = 1 + level

	#score = 0
	men = 4
	level = 0
	 
	PLAY streets_of_cairo
next_level:
	level = level + 1
	IF level = 11 THEN level = 1
	CLS

	' Fill board
	FOR c = 0 TO 19
	board(c) = RANDOM(2)
	surround(c) = 0
	NEXT c
	c = RANDOM(20)
	board(c) = 2	' Scroll
	DO
		c = RANDOM(20)
	LOOP WHILE board(c) >= 2
	board(c) = 3	' Mummy
	DO
		c = RANDOM(20)
	LOOP WHILE board(c) >= 2
	board(c) = 4	' Key
	DO
		c = RANDOM(20)
	LOOP WHILE board(c) >= 2
	board(c) = 5	' Tomb
	FOR c = 0 TO board_size - 1
	visited(c) = 0
	NEXT c
	has_scroll = 0
	has_key = 0
	has_tomb = 0
	PRINT AT 20 COLOR $2400
	PRINT "        "
	PRINT COLOR 3," "
	PRINT COLOR $2400,"             "

	FOR y = 2 TO 10 STEP 2
	PRINT AT y * 20 COLOR $2400,"  "
	PRINT COLOR 3, "                "
	PRINT COLOR $2400,"  "
	IF y <> 10 THEN
		PRINT AT y * 20 + 20 COLOR $2400,"  "
		PRINT COLOR 1," \260\261 \260\261 \260\261 \260\261 \260\261 "
		PRINT COLOR $2400,"  "
	END IF
	NEXT y
	
	PRINT AT 220 COLOR $2400,"                    "


	' Repeat level
repeat_level:
	FOR c = 0 TO 7
	SPRITE c,0
	NEXT c
	' Populate mummies
	FOR c = 0 TO 5
	mummy_y(c) = 0
	NEXT c
	FOR c = 0 TO mummies - 1
		IF (c AND 1) = 0 THEN
			mummy_x(c) = 16 + 24 * (c / 2)
		ELSE
			mummy_x(c) = 136 - 24 * (c / 2)
		END IF
		mummy_y(c) = 80
		mummy_d(c) = 1
	NEXT c

	WAIT
	BORDER 6

	PRINT AT 0 COLOR $2402,"SCORE: "
	PRINT COLOR $2401,<5>#score
	PRINT COLOR $2402," MEN: "
	PRINT COLOR $2401,<>men," "
	current_speed = 0

	x = 64
	y = 8
	dir = 4
	anim = 0
main_loop:
	' Select sprite per animation frame
	IF anim = 0 THEN spr = 40:#mirror_x = $0088
	IF anim = 1 THEN spr = 40:#mirror_x = $0488
	IF anim = 2 THEN spr = 32:#mirror_x = $0088
	IF anim = 3 THEN spr = 36:#mirror_x = $0088
	IF anim = 4 THEN spr = 44:#mirror_x = $0088
	IF anim = 5 THEN spr = 44:#mirror_x = $0488
	IF anim = 6 THEN spr = 32:#mirror_x = $0488
	IF anim = 7 THEN spr = 36:#mirror_x = $0488
	SPRITE 0,x + $0308, y + #mirror_x, spr * 8 + $0801
	SPRITE 1,x + $0308, y + #mirror_x, spr * 8 + $0816
	FOR c = 0 TO 5
		IF mummy_y(c) = 0 THEN
			SPRITE 2 + c,0
		ELSE
			d = mummy_d(c)
			IF (d = 1)+(d = 4) THEN spr = 52:IF FRAME AND 16 THEN #mirror_x = $0488 ELSE #mirror_x = $0088
			IF d = 2 THEN #mirror_x = $0088:spr = 48:IF FRAME AND 16 THEN spr = 50
			IF d = 8 THEN #mirror_x = $0488:spr = 48:IF FRAME AND 16 THEN spr = 50
			SPRITE 2 + c,mummy_x(c) + $0308, mummy_y(c) + #mirror_x, spr * 8 + $0807
		END IF
	NEXT c
	WAIT
	IF COL0 AND $00FC THEN
		IF COL0 AND $0004 THEN c = 0
		IF COL0 AND $0008 THEN c = 1
		IF COL0 AND $0010 THEN c = 2
		IF COL0 AND $0020 THEN c = 3
		IF COL0 AND $0040 THEN c = 4
		IF COL0 AND $0080 THEN c = 5
		IF has_scroll THEN
			mummy_y(c) = 0
			has_scroll = 0
			e = 1:GOSUB effect
			GOSUB update_score
		ELSEIF mummy_y(c) <> 0 THEN
			PLAY OFF
			e = 4:GOSUB effect
			FOR c = 0 TO 60
				WAIT
			NEXT c
			IF men = 0 THEN
				FOR c = 0 TO 255
					WAIT
					WAIT
					PRINT AT 225 COLOR $2400,"GAME OVER"
				NEXT c
				GOTO title_screen
			END IF
			men = men - 1
			PLAY streets_of_cairo
			GOTO repeat_level
		END IF
	END IF
	IF x = 64 THEN
		IF y = 8 THEN
			IF dir = 1 THEN
				IF level % 10 = 0 THEN
					FOR c = 0 TO 7
					SPRITE c,0
					NEXT c
					CLS
					MODE 0,0,0,0,0
					WAIT
					PRINT AT 2 COLOR 2,"!! STOP PRESS !!"
					PRINT AT 43 COLOR 6,"  British Museum"
					PRINT AT 61,"today announced"
					PRINT AT 81,"successful"
					PRINT AT 101,"excavation of"
					PRINT AT 121,"ancient Egyptian"
					PRINT AT 141,"pyramid."
					IF men < 9 THEN
						men = men + 1
					PRINT AT 183 COLOR 1,"Leader of team"
					PRINT AT 201,"given extra man"
					PRINT AT 221,"for next dig."
					END IF
					FOR c = 0 TO 255
					WAIT
					WAIT
					WAIT
					WAIT
					NEXT c
					CLS
					MODE 1
				END IF
				GOTO next_level
			END IF
		END IF
	END IF
	IF (FRAME AND 1)=0 THEN
	current_speed = current_speed + speed
	WHILE current_speed > $40
		FOR m = 0 TO mummies - 1
			x1 = mummy_x(m)
			y1 = mummy_y(m)
			IF y1 <> 0 THEN
				IF (x1 AND 7) = 0 AND (y1 AND 7) = 0 THEN
					' Mummy getting out of tomb
					d1 = mummy_d(m)
					IF d1 = 1 OR d1 = 4 THEN IF (x1 % 24) < 16 THEN mummy_d(m) = 2
					' Mummy in crossroad
					IF x1 % 24 >= 16 THEN
						IF y1 % 16 < 8 THEN
							c = RANDOM(12)
							IF c <= level THEN
								IF y < y1 THEN d1 = 1 ELSE IF y > y1 THEN d1 = 4 ELSE IF x < x1 THEN d1 = 8 ELSE IF x > x1 THEN d1 = 2
							ELSEIF c <> level + 1 THEN
								c = RANDOM(4)
								IF c = 0 THEN d1 = 1
								IF c = 1 THEN d1 = 2
								IF c = 2 THEN d1 = 4
								IF c = 3 THEN d1 = 8
							ELSE
								' No change
							END IF
							mummy_d(m) = d1
						END IF
					END IF
				END IF
			d1 = mummy_d(m)
			IF d1 = 1 THEN
				IF y1 > 16 THEN y1 = y1 - 1
			END IF
			IF d1 = 2 THEN
				IF x1 < 136 THEN x1 = x1 + 1
			END IF
			IF d1 = 4 THEN
				IF y1 < 80 THEN y1 = y1 + 1
			END IF
			IF d1 = 8 THEN
				IF x1 > 16 THEN x1 = x1 - 1
			END IF
			mummy_x(m) = x1
			mummy_y(m) = y1
			END IF
		NEXT m
		current_speed = current_speed - $40
	WEND
	END IF
	IF (FRAME AND 1)<>0 THEN
	IF (x AND 7)=0 THEN
		IF (y AND 7)=0 THEN
			a = y / 8 
			b = x / 8 - 2
			PRINT AT a * 20 + (b + 2)
			IF dir = 4 THEN PRINT $0803+0*8
			IF dir = 1 THEN PRINT $0803+1*8
			IF dir = 8 THEN PRINT $0803+2*8
			IF dir = 2 THEN PRINT $0803+3*8
			IF a >= 2 THEN
			a = a - 2
			IF (visited(a * 2 + b / 8) AND bit_table(b AND 7)) = 0 THEN
				visited(a * 2 + b / 8) = visited(a * 2 + b / 8) + bit_table(b AND 7)
				#c = (a * 16 + b) * 4
				IF reference_board(#c) <> -1 THEN c = reference_board(#c): GOSUB increase
				#c = #c + 1
				IF reference_board(#c) <> -1 THEN c = reference_board(#c): GOSUB increase
				#c = #c + 1
				IF reference_board(#c) <> -1 THEN c = reference_board(#c): GOSUB increase
				#c = #c + 1
				IF reference_board(#c) <> -1 THEN c = reference_board(#c): GOSUB increase
			END IF
			END IF
		END IF
	END IF
	IF y < 16 THEN
		c = dir
	ELSE
		c = controller_direction(cont AND $1f)
	END IF
	IF c <> 255 THEN
		IF (c = 1 OR c = 4) THEN
			IF (x AND 7) <> 0 THEN
			ELSEIF x % 24 < 16 THEN
			ELSE
				dir = c
			END IF
		ELSEIF (c = 2 OR c = 8) THEN
			IF (y AND 7) <> 0 THEN
			ELSEIF (y - 16) % 16 >= 8 THEN
			ELSE
				dir = c
			END IF
		ELSE
			dir = c
		END IF
		IF dir = 1 THEN
			anim = 0 + (FRAME AND 8) / 8
			IF y <= 16 THEN IF x = 64 THEN IF has_key = 1 AND has_tomb = 1 THEN y = y - 1
			IF y > 16 THEN y = y - 1
		END IF
		IF dir = 2 THEN
			anim = 2 + (FRAME AND 8) / 8
			IF x < 136 THEN x = x + 1
		END IF
		IF dir = 4 THEN
			anim = 4 + (FRAME AND 8) / 8
			IF y < 80 THEN y = y + 1
		END IF
		IF dir = 8 THEN
			anim = 6 + (FRAME AND 8) / 8
			IF x > 16 THEN x = x - 1
		END IF
	END IF
	END IF
	GOTO main_loop

increase:	PROCEDURE
	surround(c) = surround(c) + 1
	IF surround(c) <> 10 THEN RETURN
	a = (c / 5 * 2 + 3) * 20 + c % 5 * 3 + 3
	PRINT AT a
	d = board(c)
	IF d = 0 THEN e = 1: GOSUB effect: PRINT $1000,$1000
	IF d = 1 THEN e = 2: GOSUB effect: #score = #score + 5:PRINT $0C06+6*8,$0C06+7*8	' Sarcophagus
	IF d = 2 THEN e = 3: GOSUB effect: has_scroll = 1:PRINT $0A07+8*8,$0A07+9*8	' Scroll
	IF d = 3 THEN
		e = 4: GOSUB effect
		PRINT $0806+15*8,$1806+15*8	' Mummy
		IF mummies < 6 THEN
			mummy_x(mummies) = c % 5 * 24 + 24
			mummy_y(mummies) = c / 5 * 16 + 24
			IF y > mummy_y(mummies) THEN
				mummy_y(mummies) = mummy_y(mummies) - 1
				mummy_d(mummies) = 1
			ELSE
				mummy_y(mummies) = mummy_y(mummies) + 1
				mummy_d(mummies) = 4
			END IF
			mummies = mummies + 1	' And carried to next level
		END IF
	END IF
	IF d = 4 THEN e = 5: GOSUB effect: has_key = 1:#score = #score + 20:PRINT $0A06+10*8,$0A06+11*8	' Key
	IF d = 5 THEN e = 6: GOSUB effect: has_tomb = 1:#score = #score + 50:PRINT $0A06+12*8,$0A06+13*8	' Real sarcophagus
	GOSUB update_score
	END

update_score:	PROCEDURE
	PRINT AT 7
	IF has_scroll THEN PRINT COLOR $0206 ELSE PRINT AT 7 COLOR $2401
	PRINT <5>#score
	END

effect: PROCEDURE
	IF e < sound_effect THEN RETURN
	sound_effect = e
	sound_index = 0
	END

generate_effect:	PROCEDURE
	ON sound_effect GOTO sound_0,sound_1,sound_2,sound_3,sound_4,sound_5,sound_6
	END

sound_none:	PROCEDURE
	sound_effect = 0
	sound_index = 0
	END

sound_0:	PROCEDURE
	SOUND 2,1,0
	END

sound_1:	PROCEDURE
	SOUND 2,(FRAME AND 1)*500+3000,12
	sound_index = sound_index + 1
	IF sound_index = 5 THEN GOSUB sound_none
	END

sound_2:	PROCEDURE
	SOUND 2,200 - sound_index * 12,12
	sound_index = sound_index + 1
	IF sound_index = 5 THEN GOSUB sound_none
	END

sound_3:	PROCEDURE
	SOUND 2,(FRAME AND 1)*100+50,12
	sound_index = sound_index + 1
	IF sound_index = 5 THEN GOSUB sound_none
	END

sound_4:	PROCEDURE
	SOUND 2,1000 + sound_index * 64,12
	sound_index = sound_index + 1
	IF sound_index = 5 THEN GOSUB sound_none
	END

sound_5:	PROCEDURE
	SOUND 2,200 - sound_index * sound_index,12
	sound_index = sound_index + 1
	IF sound_index = 8 THEN GOSUB sound_none
	END

sound_6:	PROCEDURE
	SOUND 2,160 - sound_index * sound_index,12
	sound_index = sound_index + 1
	IF sound_index = 8 THEN GOSUB sound_none
	END

	' 1 - Up
	' 2 - Right
	' 4 - Down
	' 8 - Left
controller_direction:
	DATA -1, 4, 2, 4, 1,-1, 2,-1
	DATA  8, 8,-1,-1, 1,-1,-1,-1
	DATA -1, 4, 2,-1,-1,-1,-1,-1
	DATA  8,-1,-1,-1, 1,-1,-1,-1

bit_table:
	DATA $80,$40,$20,$10,$08,$04,$02,$01

reference_board:
	DATA 0,-1,-1,-1
	DATA 0,-1,-1,-1
	DATA 0,-1,-1,-1
	DATA 0,1,-1,-1
	DATA 1,-1,-1,-1
	DATA 1,-1,-1,-1
	DATA 1,2,-1,-1
	DATA 2,-1,-1,-1
	DATA 2,-1,-1,-1
	DATA 2,3,-1,-1
	DATA 3,-1,-1,-1
	DATA 3,-1,-1,-1
	DATA 3,4,-1,-1
	DATA 4,-1,-1,-1
	DATA 4,-1,-1,-1
	DATA 4,-1,-1,-1
	DATA 0,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 0,1,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 1,2,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 2,3,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 3,4,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 4,-1,-1,-1
	DATA 0,5,-1,-1
	DATA 0,5,-1,-1
	DATA 0,5,-1,-1
	DATA 0,1,5,6
	DATA 1,6,-1,-1
	DATA 1,6,-1,-1
	DATA 1,2,6,7
	DATA 2,7,-1,-1
	DATA 2,7,-1,-1
	DATA 2,3,7,8
	DATA 3,8,-1,-1
	DATA 3,8,-1,-1
	DATA 3,4,8,9
	DATA 4,9,-1,-1
	DATA 4,9,-1,-1
	DATA 4,9,-1,-1
	DATA 5,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 5,6,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 6,7,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 7,8,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 8,9,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 9,-1,-1,-1
	DATA 5,10,-1,-1
	DATA 5,10,-1,-1
	DATA 5,10,-1,-1
	DATA 5,6,10,11
	DATA 6,11,-1,-1
	DATA 6,11,-1,-1
	DATA 6,7,11,12
	DATA 7,12,-1,-1
	DATA 7,12,-1,-1
	DATA 7,8,12,13
	DATA 8,13,-1,-1
	DATA 8,13,-1,-1
	DATA 8,9,13,14
	DATA 9,14,-1,-1
	DATA 9,14,-1,-1
	DATA 9,14,-1,-1
	DATA 10,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 10,11,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 11,12,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 12,13,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 13,14,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 14,-1,-1,-1
	DATA 10,15,-1,-1
	DATA 10,15,-1,-1
	DATA 10,15,-1,-1
	DATA 10,11,15,16
	DATA 11,16,-1,-1
	DATA 11,16,-1,-1
	DATA 11,12,16,17
	DATA 12,17,-1,-1
	DATA 12,17,-1,-1
	DATA 12,13,17,18
	DATA 13,18,-1,-1
	DATA 13,18,-1,-1
	DATA 13,14,18,19
	DATA 14,19,-1,-1
	DATA 14,19,-1,-1
	DATA 14,19,-1,-1
	DATA 15,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 15,16,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 16,17,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 17,18,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 18,19,-1,-1
	DATA -1,-1,-1,-1
	DATA -1,-1,-1,-1
	DATA 19,-1,-1,-1
	DATA 15,-1,-1,-1
	DATA 15,-1,-1,-1
	DATA 15,-1,-1,-1
	DATA 15,16,-1,-1
	DATA 16,-1,-1,-1
	DATA 16,-1,-1,-1
	DATA 16,17,-1,-1
	DATA 17,-1,-1,-1
	DATA 17,-1,-1,-1
	DATA 17,18,-1,-1
	DATA 18,-1,-1,-1
	DATA 18,-1,-1,-1
	DATA 18,19,-1,-1
	DATA 19,-1,-1,-1
	DATA 19,-1,-1,-1
	DATA 19,-1,-1,-1

	'
	' Backgrounds
	'
backgrounds:
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00100000"
	BITMAP "00000000"
	BITMAP "00110000"
	BITMAP "00000010"
	BITMAP "00000000"
	BITMAP "00000110"

	BITMAP "00000000"
	BITMAP "01100000"
	BITMAP "00000000"
	BITMAP "01001100"
	BITMAP "00000000"
	BITMAP "00000100"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00001010"
	BITMAP "00001000"
	BITMAP "00000000"
	BITMAP "01000000"
	BITMAP "01010000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00101000"
	BITMAP "00001000"
	BITMAP "00000000"
	BITMAP "00000001"
	BITMAP "00000101"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "10101010"	' 4 - Non discovered
	BITMAP "01010101"
	BITMAP "10101010"
	BITMAP "01010101"
	BITMAP "10101010"
	BITMAP "01010101"
	BITMAP "10101010"
	BITMAP "01010101"

	BITMAP "10101010"
	BITMAP "01010101"
	BITMAP "10101010"
	BITMAP "01010101"
	BITMAP "10101010"
	BITMAP "01010101"
	BITMAP "10101010"
	BITMAP "01010101"

	BITMAP "00000000"	' 6 - Sarcophagus
	BITMAP "00001111"
	BITMAP "00010000"
	BITMAP "00111111"
	BITMAP "00100000"
	BITMAP "00010101"
	BITMAP "00001111"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "11110000"
	BITMAP "00001000"
	BITMAP "11111100"
	BITMAP "00000100"
	BITMAP "10101000"
	BITMAP "11110000"
	BITMAP "00000000"

	BITMAP "00000000"	' 8 - Scroll
	BITMAP "00001000"
	BITMAP "00011111"
	BITMAP "01101000"
	BITMAP "01101111"
	BITMAP "00011111"
	BITMAP "00001000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00010000"
	BITMAP "11111000"
	BITMAP "00010110"
	BITMAP "11110110"
	BITMAP "11111000"
	BITMAP "00010000"
	BITMAP "00000000"

	BITMAP "00000000"	' 10 - Key
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00111111"
	BITMAP "00101000"
	BITMAP "00100000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00111100"
	BITMAP "11100100"
	BITMAP "00111100"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"	' 12 - Real sarcophagus (50 points)
	BITMAP "00110000"
	BITMAP "00111111"
	BITMAP "00111111"
	BITMAP "00100000"
	BITMAP "00111111"
	BITMAP "00011000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00111000"
	BITMAP "11011100"
	BITMAP "11111100"
	BITMAP "00000100"
	BITMAP "11111100"
	BITMAP "00011000"
	BITMAP "00000000"

	BITMAP "00000000"	' 14 - Mummy
	BITMAP "01000000"
	BITMAP "01000000"
	BITMAP "00101000"
	BITMAP "00001000"
	BITMAP "00000100"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00100000"
	BITMAP "00100000"
	BITMAP "00010100"
	BITMAP "00000100"
	BITMAP "00000010"
	BITMAP "00000000"

	'
	' Adventurer
	'
sprites_1:
	BITMAP "00010000"	' 32
	BITMAP "00111100"
	BITMAP "00100000"
	BITMAP "00000000"
	BITMAP "00110000"
	BITMAP "00001100"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00110000"
	BITMAP "01110110"
	BITMAP "01110110"
	BITMAP "11101110"
	BITMAP "11100111"
	BITMAP "11100111"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"	' 34
	BITMAP "00000000"
	BITMAP "00010100"
	BITMAP "00011100"
	BITMAP "00001100"
	BITMAP "00110000"
	BITMAP "00111110"
	BITMAP "00111110"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "11000110"
	BITMAP "01100111"

	BITMAP "00010000"	' 36
	BITMAP "00111100"
	BITMAP "00100000"
	BITMAP "00000000"
	BITMAP "00110000"
	BITMAP "00001100"
	BITMAP "00001100"
	BITMAP "00001100"
	BITMAP "00111100"
	BITMAP "00111100"
	BITMAP "00111100"
	BITMAP "00011100"
	BITMAP "00011100"
	BITMAP "00011100"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"	' 38
	BITMAP "00000000"
	BITMAP "00010100"
	BITMAP "00011100"
	BITMAP "00001100"
	BITMAP "00110000"
	BITMAP "01110000"
	BITMAP "01110010"
	BITMAP "00000010"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00011000"
	BITMAP "00011100"

	BITMAP "00011000"	' 40
	BITMAP "00111100"
	BITMAP "00111100"
	BITMAP "00111100"
	BITMAP "00000000"
	BITMAP "00111100"
	BITMAP "01111110"
	BITMAP "00111100"
	BITMAP "00111100"
	BITMAP "00111100"
	BITMAP "00111100"
	BITMAP "00111100"
	BITMAP "01110000"
	BITMAP "01110000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"	' 42
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00011000"
	BITMAP "00000011"
	BITMAP "00000001"
	BITMAP "11000000"
	BITMAP "11000000"
	BITMAP "00000010"
	BITMAP "00000010"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "01100000"
	BITMAP "01100000"

	BITMAP "00011000"	' 44
	BITMAP "01111110"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00111100"
	BITMAP "01111110"
	BITMAP "00111100"
	BITMAP "00111100"
	BITMAP "00111100"
	BITMAP "00111100"
	BITMAP "00111100"
	BITMAP "01110000"
	BITMAP "01110000"
	BITMAP "00000000"
	BITMAP "00000000"

	BITMAP "00000000"	' 46
	BITMAP "00000000"
	BITMAP "00010100"
	BITMAP "00111100"
	BITMAP "00011000"
	BITMAP "00000011"
	BITMAP "00000001"
	BITMAP "11000000"
	BITMAP "11000000"
	BITMAP "00000010"
	BITMAP "00000010"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "00000000"
	BITMAP "01100000"
	BITMAP "01100000"

	'
	' Mommy
	'
sprites_2:
	BITMAP "00011000"	' 48
	BITMAP "00111100"
	BITMAP "00111100"
	BITMAP "00011000"
	BITMAP "00111000"
	BITMAP "01110110"
	BITMAP "01100001"
	BITMAP "01111100"
	BITMAP "00000010"
	BITMAP "00111100"
	BITMAP "00111100"
	BITMAP "00111100"
	BITMAP "00011000"
	BITMAP "00011000"
	BITMAP "00011000"
	BITMAP "00011110"

	BITMAP "00011000"	' 50
	BITMAP "00111100"
	BITMAP "00111100"
	BITMAP "00011000"
	BITMAP "00111000"
	BITMAP "01110110"
	BITMAP "01100001"
	BITMAP "01111100"
	BITMAP "00000010"
	BITMAP "00111000"
	BITMAP "00111100"
	BITMAP "00111101"
	BITMAP "00111111"
	BITMAP "01100000"
	BITMAP "11000000"
	BITMAP "11110000"

	BITMAP "00011000"	' 52
	BITMAP "00111100"
	BITMAP "00111100"
	BITMAP "00011000"
	BITMAP "01111110"
	BITMAP "10001101"
	BITMAP "10110001"
	BITMAP "10001100"
	BITMAP "10110000"
	BITMAP "00111100"
	BITMAP "00100100"	
	BITMAP "00100100"
	BITMAP "00100110"
	BITMAP "01100000"
	BITMAP "01100000"
	BITMAP "01100000"

	' 64 bitmaps
title_bitmaps_0:
	DATA $0808,$0808,$0808,$0808
	DATA $8888,$F090,$F0F0,$6060
	DATA $0000,$0000,$0300,$FF3F
	DATA $0000,$0000,$E000,$FFFF
	DATA $0000,$0000,$0000,$C000
	DATA $0000,$0301,$0000,$0000
	DATA $B371,$BFBF,$7FFF,$3D7F
	DATA $FFFF,$FFFF,$FFFF,$F7FF
	DATA $FFFF,$ED7F,$FFFF,$D9FF
	DATA $DFF9,$F9F8,$FFFB,$80C3
	DATA $40C0,$C040,$C0C0,$40C0
	DATA $0000,$0000,$0300,$0607
	DATA $0000,$0000,$FCF8,$060E
	DATA $0000,$C000,$C0C0,$C0C0
	DATA $0000,$0000,$E361,$E3E3
	DATA $0000,$0000,$8000,$8080
title_bitmaps_1:
	DATA $0000,$0C00,$0C0C,$0C0C
	DATA $1611,$2010,$382F,$4A27
	DATA $3B9E,$1DC7,$3BC5,$B3CB
	DATA $BFFF,$FFFF,$FFFF,$EFFF
	DATA $8080,$C0C0,$C0C0,$E0C0
	DATA $4040,$2020,$1010,$0810
	DATA $0C0E,$0C0C,$060C,$0107
	DATA $0606,$0E06,$1C0C,$E0F8
	DATA $FEDC,$C6E6,$C6C6,$C6C6
	DATA $0100,$0101,$0301,$0303
	DATA $B6A2,$B6B6,$3C36,$1C1C
	DATA $CC8C,$CCCC,$CCCC,$676F
	DATA $6F6D,$6C6E,$6C6C,$ECEC
	DATA $FDD9,$CDED,$CDCD,$CDCD
	DATA $FFBB,$99DD,$9999,$9999
	DATA $B830,$9D98,$8F8D,$8687
title_bitmaps_2:
	DATA $CCCC,$8CCC,$0C8C,$0C00
	DATA $0000,$0101,$0001,$0000
	DATA $814F,$0080,$C000,$E040
	DATA $02FB,$0002,$0301,$0303
	DATA $AFED,$AFBF,$5FCF,$073E
	DATA $E0E0,$E020,$F0E0,$D030
	DATA $0408,$0404,$0204,$0202
	DATA $0C06,$180C,$0018,$0000
	DATA $000C,$0000,$0000,$0000
	DATA $6078,$4020,$6040,$001F
	DATA $0201,$0202,$0202,$4282
	DATA $4FCC,$5F70,$6C78,$4957
	DATA $F010,$1010,$10F0,$B010
	DATA $0101,$0001,$0000,$0000
	DATA $0000,$8000,$8080,$4040
	DATA $2222,$2222,$2222,$2424
title_bitmaps_3:
	DATA $2A34,$3A35,$2F2A,$182E
	DATA $E070,$C060,$0080,$0000
	DATA $2040,$2020,$1010,$1010
	DATA $7F03,$0505,$0202,$0101
	DATA $B1FF,$7877,$5EBB,$6F57
	DATA $A4E4,$DCB4,$F4EC,$B87C
	DATA $6000,$7F7E,$F779,$CEE7
	DATA $0000,$E000,$5FBE,$B46C
	DATA $0808,$0408,$E404,$001C
	DATA $5BB7,$162D,$040B,$0003
	DATA $F8C8,$F8F8,$E818,$FF18
	DATA $0000,$0000,$0701,$8078
	DATA $FDBE,$FEFB,$80F0,$0000
	DATA $78D8,$00C0,$0000,$0000
	DATA $0000,$0000,$00FF,$0000
	DATA $0808,$0808,$00FF,$0000

	REM 20x12 cards
title_cards:
	DATA $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$1400,$1400,$1400,$1400,$1400,$1400,$1400,$1400,$1C00,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$1400,$1400,$1C08,$1C10,$1C18,$1C20,$1400,$1400,$1C00,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$1400,$1C28,$1C30,$1C38,$1C40,$1C48,$1C50,$2E59,$2E61,$2E69,$2600,$2E71,$2E79,$2600,$2600,$2600,$2600,$2E81,$2600
	DATA $0000,$1400,$1400,$1C88,$1C90,$1C98,$1CA0,$1CA8,$2EB1,$2EB9,$2EC1,$2EC9,$2ED1,$2ED9,$2EE1,$2EE9,$2EF1,$2EF9,$2F01,$2600
	DATA $0000,$1400,$1D08,$1D10,$1D18,$1D20,$1D28,$1D30,$2600,$2600,$2600,$2600,$2600,$2600,$2600,$2600,$2600,$2F39,$2F41,$2600
	DATA $0000,$1400,$1400,$1D48,$1D50,$1D58,$1D60,$1D68,$1D70,$1C00,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$1400,$1400,$1400,$1D78,$1D80,$1D88,$1400,$1D90,$1C00,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$1400,$1D98,$1DA0,$1DA8,$1400,$1DB0,$1DB8,$1DC0,$1C00,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$1400,$1400,$1DC8,$1DD0,$1DD8,$1DE0,$1DE8,$1400,$1C00,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$1DF0,$1DF0,$1DF0,$1DF0,$1DF0,$1DF0,$1DF0,$1DF0,$1DF8,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	DATA $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000

streets_of_cairo:
	DATA 7
	MUSIC E4,-,-
	MUSIC S,-,-
	MUSIC F4#,-,-
	MUSIC S,-,-
	MUSIC G4,E3,-
	MUSIC S,S,-
	MUSIC S,B3,-
	MUSIC S,S,-
	MUSIC F4#,B2,-
	MUSIC S,S,-
	MUSIC S,B3,-
	MUSIC S,S,-
	MUSIC E4,E3,-
	MUSIC S,S,-
	MUSIC S,B3,-
	MUSIC S,S,-
	MUSIC E4,B2,-
	MUSIC S,S,-
	MUSIC F4#,B3,-
	MUSIC S,S,-
	MUSIC G4,E3,-
	MUSIC S,S,-
	MUSIC B4,B3,-
	MUSIC S,S,-
	MUSIC F4#,B2,-
	MUSIC S,S,-
	MUSIC G4,B3,-
	MUSIC S,S,-
	MUSIC E4,E3,-
	MUSIC S,S,-
	MUSIC S,B3,-
	MUSIC S,S,-
	MUSIC G4,B2,-
	MUSIC S,S,-
	MUSIC A4,B3,-
	MUSIC S,S,-
	MUSIC B4,E3,-
	MUSIC B4,S,-
	MUSIC B4,B3,-
	MUSIC B4,S,-
	MUSIC B4,E3,-
	MUSIC S,S,-
	MUSIC C5,B3,-
	MUSIC S,S,-
	MUSIC B4,C3,-
	MUSIC S,S,-
	MUSIC A4,A3,-
	MUSIC S,S,-
	MUSIC G4,C3,-
	MUSIC S,S,-
	MUSIC A4,A3,-
	MUSIC S,S,-
	MUSIC B4,B3,-
	MUSIC S,S,-
	MUSIC -,-,-
	MUSIC -,-,-
	MUSIC F5#,A3,-
	MUSIC S,S,-
	MUSIC S,S,-
	MUSIC G5,S,-
	MUSIC E5,G3,-
	MUSIC S,S,-
	MUSIC -,-,-
	MUSIC -,-,-
	MUSIC REPEAT

